# -----------------------------------------------------------------------------
# (C) Bibix
# The content below includes confidential, proprietary information of
# Bibix. All use, disclosure, and/or reproduction is prohibited
# unless authorized in writing. All rights reserved.
# -----------------------------------------------------------------------------
# File         : ber-curve.plt
# Description  : gnuplot script for plotting a BER curve from Arx
#                simulations
# Author       : Sabih Gerez, Bibix
#                based on work by Rene Moll (DSE)
# Creation date: December 8, 2011
# -----------------------------------------------------------------------------
# $Rev: 239 $
# $Author: sabih $
# $Date: 2012-02-15 20:56:20 +0100 (Wed, 15 Feb 2012) $
# $Log$
# -----------------------------------------------------------------------------


# set xlabel "E_b/N_0 [dB]"
set xlabel "SNR [dB]"
set ylabel "BER"
set title "BER for GFSK"

set xrange [0:12] noreverse nowriteback
set xtics 1
set mxtics 0.5
# set format x "%3.2e"
set format x "%3.1f"

set yrange [] noreverse nowriteback
#set ytics 10
#set mytics 2
#set format y "%1.0e"
set format y "10^{%L}"

set log y
set grid xtics ytics mxtics mytics

set style line 1 linewidth 3 linecolor rgbcolor "red"
set style line 2 linewidth 3 linecolor rgbcolor "blue"

#set terminal postscript
# enhanced = render superscripts, etc.
# set terminal jpeg 
# set output "ber-ideal.jpg"
# set output
# enhanced = render superscripts, etc.
set termoption enhanced

   
plot "../output_itpp/bits.err" using 1:2 title "IT++, floating point" with linespoints ls 1, \
     "../output_slicer/bits.err" using 1:2 title "Arx, fixed point" with linespoints ls 2
